from diff_eq_generator import generator
from eq_to_data import eq_to_data
from basic_NN import basic_NN_test
from recreate_func import function_by_NN
from pg_NN import pg_NN
from recrate_pg_function import  function_by_pg_NN

import pandas as pd
import numpy as np
import random
from numpy.random import seed

import matplotlib.pyplot as plt
plt.ioff()

x, x_dot, x_ddot, ts, hx, gx = generator(1, 0.5, 20, 8000)
x_add, x_dot_add, x_ddot_add, ts_add, hx_add, gx_add = generator(-2, 0.8, 10, 4000)
x = np.concatenate([x, x_add])
x_dot = np.concatenate([x_dot, x_dot_add])
x_ddot = np.concatenate([x_ddot, x_ddot_add])
ts = np.concatenate([ts, ts_add])
hx = np.concatenate([hx, hx_add])
gx = np.concatenate([gx, gx_add])
x_add, x_dot_add, x_ddot_add, ts_add, hx_add, gx_add = generator(3, -1, 15, 6000)
x = np.concatenate([x, x_add])
x_dot = np.concatenate([x_dot, x_dot_add])
x_ddot = np.concatenate([x_ddot, x_ddot_add])
ts = np.concatenate([ts, ts_add])
hx = np.concatenate([hx, hx_add])
gx = np.concatenate([gx, gx_add])
x_train, y_train, hx_train, gx_train = eq_to_data(x, x_dot, x_ddot, ts, hx, gx)

x_test, x_dot_test, x_ddot_test, tst, hx_test, gx_test = generator(1.5, 0.3, 25, 10000)

#Number of seeds
N=30

avg_error_nn = []
all_pred_nn = [[0 for c in range(len(x_test)-7)] for r in range(N-1)]
avg_error_pg_nn = []
all_pred_pg_nn = [[0 for c in range(len(x_test)-7)] for r in range(N-1)]
all_error_nn = [[0 for c in range(len(x_test)-7)] for r in range(N-1)]
all_error_pg_nn = [[0 for c in range(len(x_test)-7)] for r in range(N-1)]
list_seeds=[]
time_plt =[]
for i in range(7, len(tst)):
    time_plt.append(tst[i])


for i in range(1,N):
    seed_number = int(i*10)
    random.seed(seed_number)
    seed(seed_number)
    list_seeds.append(seed_number)

    model_nn = basic_NN_test(x_train, y_train, seed_number)
    model_pg_nn = pg_NN(x_train, y_train, hx_train, gx_train, seed_number)

    x_from_nn, y_from_nn = function_by_NN(x_test, x_dot_test, tst, model_nn)
    x_from_pg_nn, y_from_pg_nn = function_by_pg_NN(x_test, x_dot_test, tst, model_pg_nn, hx_test, gx_test)

    nn_x = []
    pg_nn_x = []
    real_x = []
    nn_error = []
    pg_nn_error = []
    for j in range(len(x_from_nn)):
        nn_x.append(x_from_nn[j][0][0])
        pg_nn_x.append(x_from_pg_nn[j][0][0])
        real_x.append(x_test[j+6])
        nn_error.append(abs(x_from_nn[j][0][0] - x_test[j + 6])/abs(x_test[j + 6]))
        pg_nn_error.append(abs(x_from_pg_nn[j][0][0] - x_test[j + 6])/abs(x_test[j + 6]))
        all_pred_pg_nn[i-1][j] = x_from_pg_nn[j][0][0]
        all_pred_nn[i-1][j] = x_from_nn[j][0][0]
        all_error_pg_nn[i-1][j] = abs(x_from_pg_nn[j][0][0] - x_test[j + 6])/abs(x_test[j + 6])
        all_error_nn[i-1][j] = abs(x_from_nn[j][0][0] - x_test[j + 6])/abs(x_test[j + 6])
    avg_error_nn.append(sum(nn_error)/len(nn_error))
    avg_error_pg_nn.append(sum(pg_nn_error)/len(pg_nn_error))

    np.savez(f'./pgnn_model_{1}/result_{seed_number}.npz', xtest = real_x, pg_nn_pred = pg_nn_x, error = pg_nn_error)
    np.savez(f'./nn_model_{1}/result_{seed_number}.npz', xtest = real_x, nn_pred = nn_x, error = nn_error)

    plt.figure()
    plt.plot(time_plt, nn_x,'r', label = 'NN prediction')
    plt.plot(time_plt, pg_nn_x, 'b', label = 'PGNN prediction')
    plt.plot(time_plt, real_x, 'k', label = 'True x')
    plt.title('Network predictions vs ground truth')
    plt.xlabel('Time')
    plt.ylabel('x value')
    plt.legend()

    filename = f'./pgnn_model_{1}/pred_{seed_number}.png'
    plt.savefig(filename)
    filename = f'./nn_model_{1}/pred_{seed_number}.png'
    plt.savefig(filename)
    plt.close()

    plt.figure()
    plt.plot(nn_error,'r', label = 'NN prediction')
    plt.plot(pg_nn_error, 'b', label = 'PGNN prediction')
    plt.title('Relative errors in predictions')
    plt.xlabel('Time')
    plt.ylabel('Relative Error')
    plt.legend()

    filename = f'./pgnn_model_{1}/error_{seed_number}.png'
    plt.savefig(filename)
    filename = f'./nn_model_{1}/error_{seed_number}.png'
    plt.savefig(filename)
    plt.close()

    plt.figure()
    plt.plot(avg_error_nn,'r', label = 'NN error')
    plt.plot(avg_error_pg_nn, 'b', label = 'PGNN error')
    plt.title('Avg relative error')
    plt.xlabel('Run number')
    plt.ylabel('Relative Error')
    plt.legend()

    filename = f'./pgnn_model_{1}/avg_error.png'
    plt.savefig(filename)
    filename = f'./nn_model_{1}/avg_error.png'
    plt.savefig(filename)
    plt.close()

    np.savez(f'./pgnn_model_{1}/avg_error.npz', avg_error = avg_error_pg_nn)
    np.savez(f'./nn_model_{1}/avg_error.npz', avg_error = avg_error_nn)


avg_pred_pg_nn = []
avg_pred_nn = []
std_pg_nn = []
std_nn = []
roof_pred_pg_nn = []
floor_pred_pg_nn = []
roof_pred_nn = []
floor_pred_nn = []
for i in range(len(real_x)):
    current_step_x_pg_nn = []
    current_step_x_nn = []
    sum_pred_pg_nn = 0
    sum_pred_nn = 0
    for j in range(1,N):
        sum_pred_pg_nn = sum_pred_pg_nn + all_pred_pg_nn[j-1][i]
        sum_pred_nn = sum_pred_nn + all_pred_nn[j-1][i]
        current_step_x_pg_nn.append(all_pred_pg_nn[j-1][i])
        current_step_x_nn.append(all_pred_nn[j-1][i])
    std_pg_nn.append(np.std(current_step_x_pg_nn))
    std_nn.append(np.std(current_step_x_nn))
    avg_pred_pg_nn.append(np.float32(sum_pred_pg_nn/(N-1)))
    avg_pred_nn.append(np.float32(sum_pred_nn/(N-1)))
    roof_pred_pg_nn.append(avg_pred_pg_nn[i] +  std_pg_nn[i])
    floor_pred_pg_nn.append(avg_pred_pg_nn[i] - std_pg_nn[i])
    roof_pred_nn.append(avg_pred_nn[i] + std_nn[i])
    floor_pred_nn.append(avg_pred_nn[i] - std_nn[i])

np.savez(f'./nn_model_{1}/avg_prediction.npz', prediction = all_pred_nn)
np.savez(f'./nn_model_{1}/std.npz', std= std_nn)

np.savez(f'./pgnn_model_{1}/avg_prediction.npz', prediction = all_pred_pg_nn)
np.savez(f'./pgnn_model_{1}/std.npz', std= std_pg_nn)

plt.figure()
plt.plot(time_plt, real_x,'k', label = 'True x')
plt.plot(time_plt, avg_pred_pg_nn, 'r', label = 'x predicted by PGNN')
plt.plot(time_plt, roof_pred_pg_nn, 'b', label = 'Roof with standarddeviation', linestyle = 'dashed')
plt.plot(time_plt, floor_pred_pg_nn, 'g', label = 'Floor with standarddeviation', linestyle = 'dashed')
plt.title('Performance of prediction')
plt.xlabel('Time')
plt.ylabel('x value')
plt.legend()
plt.show()

filename = f'./pgnn_model_{1}/overall_results.png'
plt.savefig(filename)

plt.figure()
plt.plot(time_plt, real_x,'k', label = 'True x')
plt.plot(time_plt, avg_pred_nn, 'r', label = 'x predicted by NN')
plt.plot(time_plt, roof_pred_nn, 'b', label = 'Roof with standarddeviation', linestyle = 'dashed')
plt.plot(time_plt, floor_pred_nn, 'g', label = 'Floor with standarddeviation', linestyle = 'dashed')
plt.title('Performance of predictions')
plt.xlabel('Time')
plt.ylabel('x value')
plt.legend()
plt.show()

filename = f'./nn_model_{1}/overall_results.png'
plt.savefig(filename)

plt.figure()
plt.fill_between(time_plt, roof_pred_pg_nn, floor_pred_pg_nn , color ='b', alpha = 0.3)
plt.fill_between(time_plt, roof_pred_nn, floor_pred_nn , color ='r', alpha = 0.3)
plt.plot(time_plt, real_x,'k', label = 'True x')
plt.plot(time_plt, avg_pred_pg_nn, 'b', label = 'x predicted by PGNN')
plt.plot(time_plt, avg_pred_nn, 'r', label = 'x predicted by NN')
plt.title('Performance of predictions compared')
plt.xlabel('Time')
plt.ylabel('x value')
plt.legend()
plt.show()
